import { renderless as renderless$4, api as api$4 } from '@opentinyvue/vue-renderless/tabs-mf/vue';
import { defineComponent, $props, setup, h, props, hooks, $prefix, isVue2, KeepAlive } from '@opentinyvue/vue-common';
import Carousel from '@opentinyvue/vue-carousel';
import { renderless as renderless$2, api as api$2 } from '@opentinyvue/vue-renderless/tabs-mf/vue-bar';
import { IconClose, IconChevronLeft, IconPopup, IconPlus } from '@opentinyvue/vue-icon';
import Dropdown from '@opentinyvue/vue-dropdown';
import DropdownMenu from '@opentinyvue/vue-dropdown-menu';
import DropdownItem from '@opentinyvue/vue-dropdown-item';
import { renderless as renderless$1, api as api$1 } from '@opentinyvue/vue-renderless/tabs-mf/vue-nav';
import { renderless, api } from '@opentinyvue/vue-renderless/tabs-mf/vue-nav-item';
import { renderless as renderless$3, api as api$3 } from '@opentinyvue/vue-renderless/tabs-mf/vue-swipe';
import CarouselItem from '@opentinyvue/vue-carousel-item';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var __vue2_script$5 = defineComponent({
  props: _extends({}, $props, {
    title: String,
    name: String,
    selected: Boolean,
    navItem: Object
  }),
  components: {
    IconClose: IconClose()
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      mono: true
    });
  },
  render: function render() {
    var state = this.state, handleNavItemClick = this.handleNavItemClick, selected = this.selected, title = this.title, handleNavItemClose = this.handleNavItemClose, navItem = this.navItem;
    var settingClick = function settingClick2(e) {
      return e.stopPropagation();
    };
    return h("div", {
      attrs: {
        "data-tag": "tiny-tab-nav-item"
      },
      class: ["w-max h-11 sm:h-10 inline-flex flex-col justify-center group", "first:ml-3 last:mr-3 hover:cursor-pointer sm:first:pl-0 sm:last:pr-0 sm:first:ml-0 sm:last:mr-0", state.separator ? "mx-3.5 [&:last-of-type>div>span:last-of-type]:hidden [&:not(:last-of-type)]:mr-px" : "mx-3"],
      on: {
        click: handleNavItemClick
      }
    }, [h("span", {
      class: ["text-base sm:text-sm leading-6 sm:leading-5.5 group-hover:text-color-brand", state.tabSize === "large" ? "min-w-[theme(spacing.8)]" : "min-w-[theme(spacing.7)]", selected ? "text-color-brand font-bold" : "text-color-text-primary"],
      style: state.tabSize === "large" ? "font-size: 1rem" : ""
    }, [navItem.slotTitle ? navItem.slotTitle(navItem) : h("span", {}, title), navItem.slotSetting || state.withClose ? h("span", {
      class: ["pl-2 inline-flex translate-y-0.5 text-xs fill-color-icon-primary", "hover:fill-color-icon-hover focus:fill-color-icon-focus", navItem.slotSetting ? "-translate-y-0.5" : ""],
      on: {
        click: navItem.slotSetting ? settingClick : handleNavItemClose
      }
    }, [navItem.slotSetting ? navItem.slotSetting(navItem) : h(IconClose())]) : null, state.separator ? h("span", {
      attrs: {
        "data-tag": "tiny-tab-nav-item-separator"
      },
      class: "relative left-3.5 inline-flex bg-color-border-separator w-px h-3"
    }) : null])]);
  }
});
var __vue2_render$4, __vue2_staticRenderFns$4;
var __cssModules$5 = {};
var __component__$5 = /* @__PURE__ */ normalizeComponent(__vue2_script$5, __vue2_render$4, __vue2_staticRenderFns$4, false, __vue2_injectStyles$5);
function __vue2_injectStyles$5(context) {
  for (var o in __cssModules$5) {
    this[o] = __cssModules$5[o];
  }
}
var TabNavItem = /* @__PURE__ */ function() {
  return __component__$5.exports;
}();
var __vue2_script$4 = defineComponent({
  props: _extends({}, $props, {
    customClass: {
      type: String,
      default: ""
    }
  }),
  setup: function setup2(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1,
      mono: true
    });
  },
  render: function render2() {
    var state = this.state, customClass = this.customClass, m = this.m;
    return h("div", {
      attrs: {
        "data-tag": "tiny-tab-nav"
      },
      class: m("relative", customClass)
    }, [].concat(state.navItems.map(function(item) {
      return typeof item.visible === "undefined" || item.visible ? h(TabNavItem, {
        key: item.name,
        props: {
          title: item.title,
          name: item.name,
          selected: item.selected,
          navItem: item
        }
      }) : null;
    }), [h("div", {
      class: m("absolute bg-color-brand transition-all duration-300 z-20 rounded-full bottom-px h-px py-px box-content", {
        "hidden": !state.currentNav
      }),
      style: {
        width: state.currentWidth + "px",
        left: state.currentPosition + "px"
      }
    })]));
  }
});
var __vue2_render$3, __vue2_staticRenderFns$3;
var __cssModules$4 = {};
var __component__$4 = /* @__PURE__ */ normalizeComponent(__vue2_script$4, __vue2_render$3, __vue2_staticRenderFns$3, false, __vue2_injectStyles$4);
function __vue2_injectStyles$4(context) {
  for (var o in __cssModules$4) {
    this[o] = __cssModules$4[o];
  }
}
var TabNav = /* @__PURE__ */ function() {
  return __component__$4.exports;
}();
var __vue2_script$3 = defineComponent({
  props: [].concat(props),
  setup: function setup3(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$2,
      api: api$2,
      mono: true
    });
  },
  render: function render3() {
    var state = this.state, handleClickDropdownItem = this.handleClickDropdownItem, key = this.key, emitAdd = this.emitAdd, scrollToLeft = this.scrollToLeft;
    var isShowLeftButton = state.moreList.length > 0;
    var tabNavClass = isShowLeftButton ? "w-max inline-block" : "w-full inline-flex justify-around sm:w-max sm:inline-block";
    return h("div", {
      attrs: {
        "data-tag": "tiny-tab-bar"
      },
      class: "w-full h-11 sm:h-10 overflow-hidden relative"
    }, [
      h("div", {
        ref: "scroll",
        class: ["scrollbar-size-0 w-full overflow-x-auto whitespace-nowrap", "before:block before:absolute before:w-0 before:h-11 sm:before:h-10", "after:block after:absolute after:top-0 after:right-0 after:w-0 after:h-11 sm:after:h-10", "after:shadow-[-1px_-10_4px_4px_rgba(0,0,0,0.08)]", !state.moreLeft && !state.moreRight ? "before:hidden after:hidden" : "", !state.moreLeft ? "before:hidden" : "", !state.moreRight ? "after:hidden" : "", isShowLeftButton ? "sm:ml-6" : "before:shadow-[1px_-10px_4px_4px_rgba(0,0,0,0.08)]"]
      }, [h(TabNav, {
        ref: "tabNav",
        props: {
          customClass: tabNavClass
        },
        style: "margin-right:" + state.navPaddingRight + "px"
      })]),
      // 左滑按钮改为绝对定位
      isShowLeftButton ? h("div", {
        class: "hidden sm:inline-flex w-6 h-11 sm:h-10 text-sm cursor-pointer items-center justify-center absolute left-0 top-0 z-10 bg-color-bg-1",
        on: {
          click: scrollToLeft
        }
      }, [h(IconChevronLeft(), {
        class: "fill-color-icon-primary hover:fill-color-icon-focus"
      })]) : null,
      h("div", {
        class: [state.separator ? "sm:invisible" : "invisible sm:visible absolute w-full h-px bottom-px bg-color-border-separator z-10"]
      }),
      h("div", {
        ref: "tabMore",
        attrs: {
          "data-tag": "tiny-tab-more"
        },
        class: ['inline-flex w-max h-11 sm:h-10 absolute top-0 right-0 z-20 bg-color-bg-1 before:content-[""] before:block before:absolute before:bg-color-border-separator before:h-px before:w-full before:bottom-px', state.moreRight ? "shadow-[-1px_-10px_4px_4px_rgba(0,0,0,0.08)]" : ""]
      }, [state.moreList.length ? h("div", {
        class: "hidden sm:inline-block w-11 h-11 sm:h-10 text-sm cursor-pointer"
      }, [h("span", {
        class: "inline-flex w-full h-full flex-col justify-center items-center"
      }, [h(Dropdown, {
        on: {
          "item-click": handleClickDropdownItem
        },
        props: {
          showIcon: false
        }
      }, [h("span", {}, [h(IconPopup(), {
        class: "fill-color-icon-focus text-base"
      })]), h(DropdownMenu, {
        slot: "dropdown",
        props: {
          popperClass: "max-h-[theme(spacing.80)] overflow-x-hidden overflow-y-auto"
        }
      }, state.moreOptions.map(function(opt) {
        return h(DropdownItem, {
          key: key(opt),
          props: {
            itemData: opt.name
          }
        }, [opt.slotTitle ? opt.slotTitle() : opt.title]);
      }))])])]) : null, state.withAdd ? h("div", {
        attrs: {
          "data-tag": "tiny-tab-add"
        },
        class: "hidden sm:inline-block w-11 h-11 sm:h-10 text-sm cursor-pointer",
        on: {
          click: emitAdd
        }
      }, [h("span", {
        class: "inline-flex w-full h-full flex-col justify-center items-center"
      }, [h(IconPlus(), {
        class: "fill-color-icon-primary hover:fill-color-icon-focus"
      })])]) : null, state.slotCustom ? h("div", {
        attrs: {
          "data-tag": "tiny-tab-custom"
        },
        class: "hidden sm:inline-block w-max h-11 sm:h-10 text-sm"
      }, [h("span", {
        class: "inline-flex w-max h-full flex-col justify-center"
      }, [state.slotCustom()])]) : null])
    ]);
  }
});
var __vue2_render$2, __vue2_staticRenderFns$2;
var __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, __vue2_render$2, __vue2_staticRenderFns$2, false, __vue2_injectStyles$3);
function __vue2_injectStyles$3(context) {
  for (var o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var TabBar = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
var __vue2_script$2 = defineComponent({
  props: _extends({}, $props, {
    item: {
      type: Object,
      required: true
    }
  }),
  provide: function provide() {
    return {
      TabStatus: hooks.toRef(this.item, "selected")
    };
  },
  setup: function setup4(props2) {
    if (props2.item) {
      props2.item.rendered = true;
    }
  },
  render: function render4() {
    var slots = "$scopedSlots" in this ? this.$scopedSlots : this.$slots;
    return h("div", {
      attrs: {
        "data-tag": "tiny-tab-panel"
      }
    }, typeof slots.default === "function" && slots.default());
  }
});
var __vue2_render$1, __vue2_staticRenderFns$1;
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, __vue2_render$1, __vue2_staticRenderFns$1, false, __vue2_injectStyles$2);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var TabPanel = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var __vue2_script$1 = defineComponent({
  name: $prefix + "TabSwipe",
  components: {
    TinyCarouselItem: CarouselItem
  },
  props: _extends({}, $props, {
    stopThreshold: {
      type: Number,
      default: 10
    }
  }),
  setup: function setup5(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$3,
      api: api$3,
      mono: true
    });
  }
});
var render5 = function render6() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("tiny-carousel-item", {
    staticClass: "w-full !h-fit",
    attrs: {
      "data-tag": "tiny-tab-swipe"
    }
  }, [_c("div", {
    ref: "touchContainer",
    staticClass: "w-full overflow-auto scrollbar-size-0",
    attrs: {
      "data-tiny-touch-simulate-container": ""
    },
    on: {
      "&touchstart": function touchstart($event) {
        return _vm.onTouchstart.apply(null, arguments);
      },
      "&touchmove": function touchmove($event) {
        return _vm.onTouchmove.apply(null, arguments);
      }
    }
  }, [_vm._t("default")], 2)]);
};
var staticRenderFns = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render5, staticRenderFns, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var TabSwipe = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var __vue2_script = defineComponent({
  props: [].concat(props, ["activeName", "modelValue", "size", "withClose", "withAdd", "beforeLeave", "separator", "optimized", "beforeClose", "swipeable"]),
  emits: ["update:activeName", "update:modelValue", "click", "edit", "close"],
  components: {
    TabBar
  },
  setup: function setup6(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$4,
      api: api$4
    });
  },
  render: function render7() {
    var h2 = arguments[0];
    var state = this.state, slots = this.slots, optimized = this.optimized, modelValue = this.modelValue, beforeCarouselSwipe = this.beforeCarouselSwipe;
    var runFnuc = function runFnuc2(fn) {
      return typeof fn === "function" && fn() || "";
    };
    var hiddens = h2("div", {
      "attrs": {
        "data-tag": "tiny-tabs-hidden"
      },
      "class": "hidden"
    }, [runFnuc(slots.default)]);
    var tabPanel = [];
    var tabWrapper;
    if (optimized) {
      var defaultSlot, vnodes;
      if (state.currentItem) {
        defaultSlot = isVue2 ? state.currentItem.vm.$scopedSlots.default : state.currentItem.slotDefault;
      }
      vnodes = [];
      state.items.forEach(function(item) {
        if (item !== state.currentItem) {
          return;
        }
        vnodes.push(isVue2 ? h2(TabPanel, {
          props: {
            item
          },
          key: state.currentItem.name,
          scopedSlots: {
            default: function _default() {
              return runFnuc(defaultSlot);
            }
          }
        }) : h2(TabPanel, {
          props: {
            item
          },
          key: state.currentItem.name
        }, function() {
          return runFnuc(defaultSlot);
        }));
      });
      tabPanel.push(isVue2 ? h2(KeepAlive, [vnodes]) : h2(KeepAlive, {}, function() {
        return vnodes;
      }));
    } else {
      state.items.forEach(function(item, i) {
        if (item.lazy && item !== state.currentItem && !item.rendered) {
          return;
        }
        var itemDefSlot = isVue2 ? item.vm.$scopedSlots.default : item.slotDefault;
        var props2 = {
          style: {
            display: item === state.currentItem || state.swipeable ? "block" : "none"
          },
          attrs: {
            "data-tag": "tiny-tab-panel"
          },
          class: "w-full",
          props: {
            item
          },
          key: item.name
        };
        var tabItem = isVue2 ? h2(TabPanel, _extends({
          scopedSlots: {
            default: function _default() {
              return runFnuc(itemDefSlot);
            }
          }
        }, props2)) : h2(TabPanel, props2, function() {
          return runFnuc(itemDefSlot);
        });
        var tabSwipe;
        if (state.swipeable) {
          tabSwipe = isVue2 ? h2(TabSwipe, {
            ref: "tabSwipe" + i,
            scopedSlots: {
              default: function _default() {
                return [tabItem];
              }
            }
          }) : h2(TabSwipe, {
            ref: "tabSwipe" + i
          }, function() {
            return [tabItem];
          });
        }
        tabPanel.push(state.swipeable ? tabSwipe : tabItem);
      });
      if (state.swipeable) {
        var initialIndex = 0;
        if (state.items.length > 0 && modelValue) {
          initialIndex = state.items.map(function(item) {
            return item.name;
          }).indexOf(modelValue);
        }
        tabWrapper = h2(Carousel, {
          ref: "swipe",
          props: {
            loop: false,
            swipeable: true,
            lite: true,
            initialIndex,
            beforeSwipe: beforeCarouselSwipe,
            height: state.maxTabSwipeHeight + "px"
          },
          class: '!rounded-none [&_>[data-tag="tiny-carousel-block"]]:!rounded-none'
        }, tabPanel);
      }
    }
    return h2("div", {
      "attrs": {
        "data-tag": "tiny-tabs"
      }
    }, [hiddens, h2("tab-bar", {
      "ref": "tabbar"
    }), state.swipeable ? tabWrapper : tabPanel]);
  }
});
var __vue2_render, __vue2_staticRenderFns;
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, __vue2_render, __vue2_staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
